import { PrrayPromise } from './prraypromise';
export default class Prray<T> extends Array<T> {
    static of<T>(...args: T[]): Prray<T>;
    static isPrray(obj: any): boolean;
    static from<T>(arrayLike: Iterable<T> | ArrayLike<T>): Prray<T>;
    static from<T, U>(arrayLike: Iterable<T> | ArrayLike<T>, mapFunc: (v: T, ix: number) => U, thisArg?: any): Prray<U>;
    constructor(length: number);
    constructor(...args: T[]);
    mapAsync<U>(func: (currentValue: T, index: number, prray: Prray<T>) => Promise<U> | U, opts?: {
        concurrency: number;
    }): PrrayPromise<U>;
    map<U>(func: (currentValue: T, index: number, prray: Prray<T>) => U): Prray<U>;
    filterAsync(func: (currentValue: T, index: number, prray: Prray<T>) => Promise<boolean> | boolean, opts?: {
        concurrency: number;
    }): PrrayPromise<T>;
    filter(func: (currentValue: T, index: number, prray: Prray<T>) => boolean): Prray<T>;
    reduceAsync(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T | Promise<T>): Promise<T>;
    reduceAsync(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T | Promise<T>, initialValue: T): Promise<T>;
    reduceAsync<U>(func: (accumulator: U, currentValue: T, index: number, prray: Prray<T>) => U | Promise<U>, initialValue: U): Promise<U>;
    reduce(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T): T;
    reduce(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T, initialValue: T): T;
    reduce<U>(func: (accumulator: U, currentValue: T, index: number, prray: Prray<T>) => U, initialValue: U): U;
    reduceRightAsync(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T | Promise<T>): Promise<T>;
    reduceRightAsync(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T | Promise<T>, initialValue: T): Promise<T>;
    reduceRightAsync<U>(func: (accumulator: U, currentValue: T, index: number, prray: Prray<T>) => U | Promise<U>, initialValue: U): Promise<U>;
    reduceRight(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T): T;
    reduceRight(func: (accumulator: T, currentValue: T, index: number, prray: Prray<T>) => T, initialValue: T): T;
    reduceRight<U>(func: (accumulator: U, currentValue: T, index: number, prray: Prray<T>) => U, initialValue: U): U;
    sortAsync(func?: (a: T, b: T) => Promise<number> | number): PrrayPromise<T>;
    findAsync(func: (currentValue: T, index: number, prray: Prray<T>) => Promise<boolean> | boolean): Promise<T | undefined>;
    find(func: (currentValue: T, index: number, prray: Prray<T>) => boolean): T | undefined;
    findIndexAsync(func: (currentValue: T, index: number, prray: Prray<T>) => Promise<boolean> | boolean): Promise<number>;
    findIndex(func: (currentValue: T, index: number, prray: Prray<T>) => boolean): number;
    everyAsync(func: (currentValue: T, index: number, prray: Prray<T>) => Promise<boolean> | boolean, opts?: {
        concurrency: number;
    }): Promise<boolean>;
    every(func: (currentValue: T, index: number, prray: Prray<T>) => boolean): boolean;
    someAsync(func: (currentValue: T, index: number, prray: Prray<T>) => Promise<boolean> | boolean, opts?: {
        concurrency: number;
    }): Promise<boolean>;
    some(func: (currentValue: T, index: number, prray: Prray<T>) => boolean): boolean;
    forEachAsync(func: (currentValue: T, index: number, prray: Prray<T>) => Promise<any> | any, opts?: {
        concurrency: number;
    }): Promise<undefined>;
    forEach(func: (currentValue: T, index: number, prray: Prray<T>) => any): undefined;
    slice(start?: number, end?: number): Prray<T>;
    concat(...items: ConcatArray<T>[]): Prray<T>;
    concat(...items: (ConcatArray<T> | T)[]): Prray<T>;
    reverse(): Prray<T>;
    splice(start: number): Prray<T>;
    splice(start: number, deleteCount: number): Prray<T>;
    splice(start: number, deleteCount: number, ...items: T[]): Prray<T>;
    toArray(): T[];
}
export declare function _ensurePrray<T>(arr: T[]): Prray<T>;
//# sourceMappingURL=prray.d.ts.map