"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const prraypromise_1 = require("./prraypromise");
const methods = require("./methods");
// TODO: thisArg
class Prray extends Array {
    static of(...args) {
        return Prray.from(args);
    }
    static isPrray(obj) {
        return obj instanceof Prray;
    }
    static from(arrayLike, mapFunc, thisArg) {
        const arr = mapFunc === undefined ? super.from(arrayLike) : super.from(arrayLike, mapFunc, thisArg);
        const prr = new Prray();
        for (let i = arr.length - 1; i >= 0; i--) {
            prr[i] = arr[i];
        }
        return prr;
    }
    constructor(...args) {
        super(...args);
    }
    mapAsync(func, opts) {
        const promise = methods.mapAsync(this, func, opts);
        return prraypromise_1.prraypromise(promise.then(arr => Prray.from(arr)));
    }
    map(func) {
        return _ensurePrray(methods.map(this, func));
    }
    filterAsync(func, opts) {
        const promise = methods.filterAsync(this, func, opts);
        return prraypromise_1.prraypromise(promise.then(arr => Prray.from(arr)));
    }
    filter(func) {
        return _ensurePrray(methods.filter(this, func));
    }
    reduceAsync(func, initialValue) {
        const promise = methods.reduceAsync(this, func, initialValue);
        return promise;
    }
    reduce(func, initialValue) {
        return methods.reduce(this, func, initialValue);
    }
    reduceRightAsync(func, initialValue) {
        const promise = methods.reduceRightAsync(this, func, initialValue);
        return promise;
    }
    reduceRight(func, initialValue) {
        return methods.reduceRight(this, func, initialValue);
    }
    sortAsync(func) {
        const promise = methods.sortAsync(this, func);
        return prraypromise_1.prraypromise(promise);
    }
    findAsync(func) {
        return methods.findAsync(this, func);
    }
    find(func) {
        return methods.find(this, func);
    }
    findIndexAsync(func) {
        return methods.findIndexAsync(this, func);
    }
    findIndex(func) {
        return methods.findIndex(this, func);
    }
    everyAsync(func, opts) {
        return methods.everyAsync(this, func, opts);
    }
    every(func) {
        return methods.every(this, func);
    }
    someAsync(func, opts) {
        return methods.someAsync(this, func, opts);
    }
    some(func) {
        return methods.some(this, func);
    }
    forEachAsync(func, opts) {
        return methods.forEachAsync(this, func, opts);
    }
    forEach(func) {
        return methods.forEach(this, func);
    }
    slice(start, end) {
        const result = super.slice(start, end);
        return _ensurePrray(result);
    }
    concat(...items) {
        return _ensurePrray(super.concat(...items));
    }
    reverse() {
        return super.reverse();
    }
    splice(start, deleteCount, ...items) {
        // Why? If pass parameter deleteCount as undefined directly, the delete count will be zero actually :(
        const result = deleteCount === undefined ? super.splice(start) : super.splice(start, deleteCount, ...items);
        return _ensurePrray(result);
    }
    toArray() {
        return [...this];
    }
}
exports.default = Prray;
function _ensurePrray(arr) {
    if (arr instanceof Prray) {
        return arr;
    }
    else {
        return Prray.from(arr);
    }
}
exports._ensurePrray = _ensurePrray;
