"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
ava_1.default('prray concat', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.deepEqual(prray_1.default.from([1, 2]).concat([3, 4]), prray_1.default.from([1, 2, 3, 4]));
    t.deepEqual(prray_1.default.from([1, 2]).concat([3, 4], [5, 6]), prray_1.default.from([1, 2, 3, 4, 5, 6]));
    t.deepEqual(prray_1.default.from([1, 2]).concat(3, [4, 5]), prray_1.default.from([1, 2, 3, 4, 5]));
    t.deepEqual(prray_1.default.from([[1]]).concat([2, [3]]), prray_1.default.from([[1], 2, [3]]));
    t.deepEqual(prray_1.default.from([[1]]).concat(4, [5, [6]]), prray_1.default.from([[1], 4, 5, [6]]));
    const prr = prray_1.default.from([1, 2]);
    t.not(prr.concat([3, 4]), prr); // Immutable
}));
ava_1.default('prraypromise concat', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2]).concat([3, 4]), prray_1.default.from([1, 2, 3, 4]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2]).concat([3, 4], [5, 6]), prray_1.default.from([1, 2, 3, 4, 5, 6]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2]).concat(3, [4, 5]), prray_1.default.from([1, 2, 3, 4, 5]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([[1]]).concat([2, [3]]), prray_1.default.from([[1], 2, [3]]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([[1]]).concat(4, [5, [6]]), prray_1.default.from([[1], 4, 5, [6]]));
    const prr = prray_1.default.from([1, 2]);
    t.not(yield test_utils_1.toPrrayPromise(prr).concat([3, 4]), prr); // Immutable
}));
