"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
ava_1.default('prray copyWithin', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const arr = [1, 2, 3, 4, 5];
    const prr = prray_1.default.from([1, 2, 3, 4, 5]);
    t.is(prr.copyWithin(-2, 0), prr);
    t.deepEqual(prr.copyWithin(-2, 0), prray_1.default.from(arr.copyWithin(-2, 0)));
    t.deepEqual(prr.copyWithin(0, 3), prray_1.default.from(arr.copyWithin(0, 3)));
    t.deepEqual(prr.copyWithin(0, 3, 4), prray_1.default.from(arr.copyWithin(0, 3, 4)));
    t.deepEqual(prr.copyWithin(-2, -3, -1), prray_1.default.from(arr.copyWithin(-2, -3, -1)));
    t.is(prr.copyWithin(-2, -3, -1), prr); // mutable
}));
ava_1.default('prraypromise copyWithin', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const arr = [1, 2, 3, 4, 5];
    const prr = prray_1.default.from([1, 2, 3, 4, 5]);
    t.is(yield test_utils_1.toPrrayPromise(prr).copyWithin(-2, 0), prr);
    t.deepEqual(yield test_utils_1.toPrrayPromise(prr).copyWithin(-2, 0), prray_1.default.from(arr.copyWithin(-2, 0)));
    t.deepEqual(yield test_utils_1.toPrrayPromise(prr).copyWithin(0, 3), prray_1.default.from(arr.copyWithin(0, 3)));
    t.deepEqual(yield test_utils_1.toPrrayPromise(prr).copyWithin(0, 3, 4), prray_1.default.from(arr.copyWithin(0, 3, 4)));
    t.deepEqual(yield test_utils_1.toPrrayPromise(prr).copyWithin(-2, -3, -1), prray_1.default.from(arr.copyWithin(-2, -3, -1)));
    t.is(yield test_utils_1.toPrrayPromise(prr).copyWithin(-2, -3, -1), prr); // mutable
}));
