"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
ava_1.default('prray fill', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4), prray_1.default.from([4, 4, 4]));
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4, 1), prray_1.default.from([1, 4, 4]));
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4, 1, 2), prray_1.default.from([1, 4, 3]));
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4, 1, 1), prray_1.default.from([1, 2, 3]));
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4, 3, 3), prray_1.default.from([1, 2, 3]));
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4, -3, -2), prray_1.default.from([4, 2, 3]));
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4, NaN, NaN), prray_1.default.from([1, 2, 3]));
    t.deepEqual(prray_1.default.from([1, 2, 3]).fill(4, 3, 5), prray_1.default.from([1, 2, 3]));
    t.deepEqual(new prray_1.default(3).fill(4), prray_1.default.from([4, 4, 4]));
    const prr = new prray_1.default(3).fill({}); // [{}, {}, {}];
    t.deepEqual(prr, prray_1.default.from([{}, {}, {}]));
    prr[0].hi = 'hi';
    t.deepEqual(prr, prray_1.default.from([{ hi: 'hi' }, { hi: 'hi' }, { hi: 'hi' }]));
}));
ava_1.default('prray fill: mutable', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from([1, 2, 3]);
    t.is(prr.fill(4), prr);
}));
ava_1.default('prraypromise fill', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4), prray_1.default.from([4, 4, 4]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4, 1), prray_1.default.from([1, 4, 4]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4, 1, 2), prray_1.default.from([1, 4, 3]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4, 1, 1), prray_1.default.from([1, 2, 3]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4, 3, 3), prray_1.default.from([1, 2, 3]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4, -3, -2), prray_1.default.from([4, 2, 3]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4, NaN, NaN), prray_1.default.from([1, 2, 3]));
    t.deepEqual(yield test_utils_1.toPrrayPromise([1, 2, 3]).fill(4, 3, 5), prray_1.default.from([1, 2, 3]));
    t.deepEqual(yield test_utils_1.toPrrayPromise(new Array(3)).fill(4), prray_1.default.from([4, 4, 4]));
    const prr = yield test_utils_1.toPrrayPromise(new Array(3)).fill({}); // [{}, {}, {}];
    t.deepEqual(prr, prray_1.default.from([{}, {}, {}]));
    prr[0].hi = 'hi';
    t.deepEqual(prr, prray_1.default.from([{ hi: 'hi' }, { hi: 'hi' }, { hi: 'hi' }]));
}));
ava_1.default('prraypromise fill: mutable', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from([1, 2, 3]);
    t.is(yield test_utils_1.toPrrayPromise(prr).fill(4), prr);
}));
