"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const test_utils_1 = require("./test-utils");
const prray_1 = require("../src/prray");
ava_1.default('prray findIndex', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from([1, 2, 3, 4]);
    t.is(prr.findIndex(x => x === 2), 1);
    t.is(prr.findIndex(x => x === 10), -1);
}));
ava_1.default('prray findIndex: order', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from([{ a: 1 }, { a: 2 }]);
    t.deepEqual(prr.findIndex(x => x.a > 0), 0);
    t.is(prr.findIndex(x => x.a > 10), -1);
}));
ava_1.default('prraypromise findIndex', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([1, 2, 3, 4]);
    t.is(yield pp.findIndex(x => x === 2), 1);
    t.is(yield pp.findIndex(x => x === 10), -1);
}));
ava_1.default('prraypromise findIndex: order', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([{ a: 1 }, { a: 2 }]);
    t.deepEqual(yield pp.findIndex(x => x.a > 0), 0);
    t.is(yield pp.findIndex(x => x.a > 10), -1);
}));
