"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
ava_1.default('prray from', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p1 = prray_1.default.from('foo');
    t.true(p1 instanceof prray_1.default);
    t.is(p1[0], 'f');
    t.is(p1[1], 'o');
    t.is(p1[2], 'o');
    t.is(p1.length, 3);
    const p2 = prray_1.default.from(['foo', 1]);
    t.true(p2 instanceof prray_1.default);
    t.is(p2[0], 'foo');
    t.is(p2[1], 1);
    t.is(p2.length, 2);
    const p3 = prray_1.default.from([1, 2, 3], x => x + x);
    t.true(p3 instanceof prray_1.default);
    t.is(p3[0], 2);
    t.is(p3[1], 4);
    t.is(p3[2], 6);
    t.is(p3.length, 3);
    function f() {
        return Array.from(arguments);
    }
    const p4 = prray_1.default.from(f(1, 2, 3));
    t.true(p4 instanceof prray_1.default);
    t.is(p4[0], 1);
    t.is(p4[1], 2);
    t.is(p4[2], 3);
    t.is(p4.length, 3);
    const p5 = prray_1.default.from([1]);
    t.true(p5 instanceof prray_1.default);
    t.is(p5[0], 1);
    t.is(p5.length, 1);
}));
