"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
ava_1.default('prray isPrray', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.true(prray_1.default.isPrray(new prray_1.default(1, 2, 3)));
    t.true(prray_1.default.isPrray(prray_1.default.of(1, 2, 3)));
    t.true(prray_1.default.isPrray(prray_1.default.from([1, 2, 3])));
    t.true(prray_1.default.isPrray(prray_1.default.from([1, 2, 3])));
    t.false(prray_1.default.isPrray([1, 2, 3]));
    t.false(prray_1.default.isPrray(new Array(1, 2, 3)));
    t.false(prray_1.default.isPrray({ foo: [1, 2, 3] }));
    t.false(prray_1.default.isPrray('1,2,3'));
    t.false(prray_1.default.isPrray(undefined));
    t.false(prray_1.default.isPrray(null));
    t.false(prray_1.default.isPrray(1));
    t.false(prray_1.default.isPrray({}));
    t.false(prray_1.default.isPrray(Object));
    t.false(prray_1.default.isPrray(prray_1.default));
    t.false(prray_1.default.isPrray(console.log));
}));
