"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
const p = prray_1.default.from([1, 2, 3, 4]);
const pp = test_utils_1.toPrrayPromise([1, 2, 3, 4]);
ava_1.default('prray join', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.is(p.join(), '1,2,3,4');
    t.is(p.join('-'), '1-2-3-4');
    t.is(p.join('xx'), '1xx2xx3xx4');
}));
ava_1.default('prraypromise join', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.is(yield pp.join(), '1,2,3,4');
    t.is(yield pp.join('-'), '1-2-3-4');
    t.is(yield pp.join('xx'), '1xx2xx3xx4');
}));
