"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const test_utils_1 = require("./test-utils");
const prray_1 = require("../src/prray");
const p = prray_1.default.from(['a', 'b', 'c', 'd']);
const pp = test_utils_1.toPrrayPromise(['a', 'b', 'c', 'd']);
ava_1.default('prray lastIndexOf', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.is(p.lastIndexOf('c'), 2);
    t.is(p.lastIndexOf('z'), -1);
    t.is(p.lastIndexOf(undefined), -1);
    t.is(p.lastIndexOf('c', 2), 2);
    t.is(p.lastIndexOf('c', 1), -1);
}));
ava_1.default('prraypromise lastIndexOf', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.deepEqual(yield pp, p);
    t.is(yield pp.lastIndexOf('c'), 2);
    t.is(yield pp.lastIndexOf('z'), -1);
    t.is(yield pp.lastIndexOf(undefined), -1);
    t.is(yield pp.lastIndexOf('c', 2), 2);
    t.is(yield pp.lastIndexOf('c', 1), -1);
}));
