"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const prraypromise_1 = require("../src/prraypromise");
const test_utils_1 = require("./test-utils");
ava_1.default('prray mapAsync', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = prray_1.default.from([1, 2, 3]);
    t.true(p.mapAsync(test_utils_1.addOneAsync) instanceof prraypromise_1.PrrayPromise);
    t.true(p.mapAsync(test_utils_1.addOne) instanceof prraypromise_1.PrrayPromise);
    t.deepEqual(yield p.mapAsync(test_utils_1.addOneAsync), prray_1.default.from([2, 3, 4]));
    t.deepEqual(yield p.mapAsync(test_utils_1.addOne), prray_1.default.from([2, 3, 4]));
    t.deepEqual(yield p.mapAsync(test_utils_1.addOneAsync, { concurrency: 2 }), prray_1.default.from([2, 3, 4]));
}));
ava_1.default('prraypromise mapAsync', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([1, 2, 3]);
    t.true(pp.mapAsync(test_utils_1.addOneAsync) instanceof prraypromise_1.PrrayPromise);
    t.true(pp.mapAsync(test_utils_1.addOne) instanceof prraypromise_1.PrrayPromise);
    t.deepEqual(yield pp.mapAsync(test_utils_1.addOneAsync), prray_1.default.from([2, 3, 4]));
    t.deepEqual(yield pp.mapAsync(test_utils_1.addOne), prray_1.default.from([2, 3, 4]));
    t.deepEqual(yield pp.mapAsync(test_utils_1.addOneAsync, { concurrency: 2 }), prray_1.default.from([2, 3, 4]));
}));
