"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
const arr = ['a', 'b', 'c', 'd'];
ava_1.default('prray pop', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = prray_1.default.from(arr);
    t.is(p.pop(), 'd');
    t.is(p.pop(), 'c');
    t.is(p.pop(), 'b');
    t.is(p.pop(), 'a');
    t.is(p.pop(), undefined);
    t.deepEqual(p, prray_1.default.from([])); // mutable
}));
ava_1.default('prraypromise pop', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise(arr);
    t.is(yield pp.pop(), 'd');
    t.is(yield pp.pop(), 'c');
    t.is(yield pp.pop(), 'b');
    t.is(yield pp.pop(), 'a');
    t.is(yield pp.pop(), undefined);
    t.deepEqual(yield pp, prray_1.default.from([])); // mutable
}));
