"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const index_1 = require("../src/index");
const test_utils_1 = require("./test-utils");
ava_1.default('Real world test 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = yield index_1.default.from([1, 2, 3])
        .map(v => v + 1)
        .mapAsync(v => test_utils_1.delay(100).then(() => v + 2))
        .concat([4, 5, 6])
        .filterAsync(v => test_utils_1.delay(100).then(() => v % 2 === 0))
        .toArray();
    const a = [1, 2, 3]
        .map(v => v + 1)
        .map(v => v + 2)
        .concat([4, 5, 6])
        .filter(v => v % 2 === 0);
    t.deepEqual(p, a);
}));
ava_1.default('Real world test 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = yield index_1.default.from(['e', 'a', 'f', 'd'])
        .mapAsync(v => v + v)
        .sortAsync()
        .join('---');
    const a = ['e', 'a', 'f', 'd']
        .map(v => v + v)
        .sort()
        .join('---');
    t.deepEqual(p, a);
}));
