"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
require("source-map-support/register");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
const asyncFunc1 = (pre, c) => test_utils_1.delay(100).then(() => pre + c);
const func1 = (pre, c) => pre + c;
const asyncFunc2 = (pre, c) => __awaiter(void 0, void 0, void 0, function* () {
    yield test_utils_1.delay(100);
    pre.push(c + 1);
    return pre;
});
const func2 = (pre, c) => {
    pre.push(c + 1);
    return pre;
};
ava_1.default('prray reduceAsync 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = prray_1.default.from([1, 2, 3]);
    t.true(p.reduceAsync(asyncFunc1) instanceof Promise);
    t.deepEqual(yield p.reduceAsync(asyncFunc1), [1, 2, 3].reduce(func1));
    t.deepEqual(yield p.reduceAsync(asyncFunc1, 10), [1, 2, 3].reduce(func1, 10));
}));
ava_1.default('prray reduceAsync 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = prray_1.default.from([1, 2, 3]);
    t.true(p.reduceAsync(asyncFunc2, []) instanceof Promise);
    t.deepEqual(yield p.reduceAsync(asyncFunc2, []), [1, 2, 3].reduce(func2, []));
    t.deepEqual(yield p.reduceAsync(asyncFunc2, []), [1, 2, 3].reduce(func2, []));
}));
ava_1.default('prraypromise reduceAsync 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([1, 2, 3]);
    t.true(pp.reduceAsync(asyncFunc1) instanceof Promise);
    t.deepEqual(yield pp.reduceAsync(asyncFunc1), [1, 2, 3].reduce(func1));
    t.deepEqual(yield pp.reduceAsync(asyncFunc1, 10), [1, 2, 3].reduce(func1, 10));
}));
ava_1.default('prraypromise reduceAsync 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([1, 2, 3]);
    t.true(pp.reduceAsync(asyncFunc2, []) instanceof Promise);
    t.deepEqual(yield pp.reduceAsync(asyncFunc2, []), [1, 2, 3].reduce(func2, []));
    t.deepEqual(yield pp.reduceAsync(asyncFunc2, []), [1, 2, 3].reduce(func2, []));
}));
