"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
const func1 = (pre, c) => pre + c;
const func2 = (pre, c) => {
    pre.push(c + 1);
    return pre;
};
ava_1.default('prray reduceRight 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = prray_1.default.from([1, 2, 3]);
    t.deepEqual(p.reduceRight(func1), [1, 2, 3].reduceRight(func1));
    t.deepEqual(p.reduceRight(func1, 10), [1, 2, 3].reduceRight(func1, 10));
}));
ava_1.default('prray reduceRight 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = prray_1.default.from([1, 2, 3]);
    t.deepEqual(p.reduceRight(func2, []), [1, 2, 3].reduceRight(func2, []));
    t.deepEqual(p.reduceRight(func2, []), [1, 2, 3].reduceRight(func2, []));
}));
ava_1.default('prray reduceRight 3', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const p = prray_1.default.from([1, 2, 3]);
    t.deepEqual(p.reduceRight(func2, new prray_1.default()), [1, 2, 3].reduceRight(func2, new prray_1.default()));
    t.deepEqual(p.reduceRight(func2, new prray_1.default()), [1, 2, 3].reduceRight(func2, new prray_1.default()));
}));
ava_1.default('prraypromise reduceRight 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([1, 2, 3]);
    t.deepEqual(yield pp.reduceRight(func1), [1, 2, 3].reduceRight(func1));
    t.deepEqual(yield pp.reduceRight(func1, 10), [1, 2, 3].reduceRight(func1, 10));
}));
ava_1.default('prraypromise reduceRight 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([1, 2, 3]);
    t.deepEqual(yield pp.reduceRight(func2, []), [1, 2, 3].reduceRight(func2, []));
    t.deepEqual(yield pp.reduceRight(func2, []), [1, 2, 3].reduceRight(func2, []));
}));
ava_1.default('prraypromise reduceRight 3', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const pp = test_utils_1.toPrrayPromise([1, 2, 3]);
    t.deepEqual(yield pp.reduceRight(func2, new prray_1.default()), [1, 2, 3].reduceRight(func2, new prray_1.default()));
    t.deepEqual(yield pp.reduceRight(func2, new prray_1.default()), [1, 2, 3].reduceRight(func2, new prray_1.default()));
}));
