"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const prraypromise_1 = require("../src/prraypromise");
const test_utils_1 = require("./test-utils");
const arr = [1, 2, 3, 4];
ava_1.default('prray reverse', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(arr);
    t.deepEqual(prr.reverse(), prray_1.default.from([4, 3, 2, 1]));
    t.deepEqual(prr, prray_1.default.from([4, 3, 2, 1])); // mutable
}));
ava_1.default('prraypromise reverse', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(arr);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.reverse(), prray_1.default.from([4, 3, 2, 1]));
    t.deepEqual(prr, prray_1.default.from([4, 3, 2, 1])); // mutable
    t.true(pp.reverse() instanceof prraypromise_1.PrrayPromise);
}));
