"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const prraypromise_1 = require("../src/prraypromise");
const test_utils_1 = require("./test-utils");
const arr = [1, 2, 3, 4, 5, 6, 7, 8, 9];
const p = prray_1.default.from(arr);
const pp = test_utils_1.toPrrayPromise(arr);
ava_1.default('prray slice', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.true(p.slice(1) instanceof prray_1.default);
    t.deepEqual(p.slice(), prray_1.default.from(arr.slice()));
    t.deepEqual(p.slice(2), prray_1.default.from(arr.slice(2)));
    t.deepEqual(p.slice(undefined, 7), prray_1.default.from(arr.slice(undefined, 7)));
    t.deepEqual(p.slice(1, 5), prray_1.default.from(arr.slice(1, 5)));
    t.deepEqual(p.slice(4, 100), prray_1.default.from(arr.slice(4, 100)));
    t.deepEqual(p.slice(100, 200), prray_1.default.from(arr.slice(100, 200)));
    t.deepEqual(p.slice(-3), prray_1.default.from(arr.slice(-3)));
    t.deepEqual(p.slice(undefined, -4), prray_1.default.from(arr.slice(undefined, -4)));
    t.deepEqual(p.slice(-2, -5), prray_1.default.from(arr.slice(-2, -5)));
    t.deepEqual(p.slice(-5, -2), prray_1.default.from(arr.slice(-5, -2)));
    t.deepEqual(p.slice(-4, -100), prray_1.default.from(arr.slice(-4, -100)));
    t.deepEqual(p.slice(-100, -4), prray_1.default.from(arr.slice(-100, -4)));
    t.deepEqual(p.slice(-200, -100), prray_1.default.from(arr.slice(-200, -100)));
    t.deepEqual(p.slice(-7, 5), prray_1.default.from(arr.slice(-7, 5)));
    t.deepEqual(p.slice(1, -3), prray_1.default.from(arr.slice(1, -3)));
    t.deepEqual(p.slice(-1000, 3), prray_1.default.from(arr.slice(-1000, 3)));
    t.deepEqual(p.slice(-3, 1000), prray_1.default.from(arr.slice(-3, 1000)));
    t.not(p.slice(-3, 1000), p); // Immutable
}));
ava_1.default('prraypromise slice', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.true(pp.slice(1) instanceof prraypromise_1.PrrayPromise);
    t.deepEqual(yield pp.slice(), prray_1.default.from(arr.slice()));
    t.deepEqual(yield pp.slice(2), prray_1.default.from(arr.slice(2)));
    t.deepEqual(yield pp.slice(undefined, 7), prray_1.default.from(arr.slice(undefined, 7)));
    t.deepEqual(yield pp.slice(1, 5), prray_1.default.from(arr.slice(1, 5)));
    t.deepEqual(yield pp.slice(4, 100), prray_1.default.from(arr.slice(4, 100)));
    t.deepEqual(yield pp.slice(100, 200), prray_1.default.from(arr.slice(100, 200)));
    t.deepEqual(yield pp.slice(-3), prray_1.default.from(arr.slice(-3)));
    t.deepEqual(yield pp.slice(undefined, -4), prray_1.default.from(arr.slice(undefined, -4)));
    t.deepEqual(yield pp.slice(-2, -5), prray_1.default.from(arr.slice(-2, -5)));
    t.deepEqual(yield pp.slice(-5, -2), prray_1.default.from(arr.slice(-5, -2)));
    t.deepEqual(yield pp.slice(-4, -100), prray_1.default.from(arr.slice(-4, -100)));
    t.deepEqual(yield pp.slice(-100, -4), prray_1.default.from(arr.slice(-100, -4)));
    t.deepEqual(yield pp.slice(-200, -100), prray_1.default.from(arr.slice(-200, -100)));
    t.deepEqual(yield pp.slice(-7, 5), prray_1.default.from(arr.slice(-7, 5)));
    t.deepEqual(yield pp.slice(1, -3), prray_1.default.from(arr.slice(1, -3)));
    t.deepEqual(yield pp.slice(-1000, 3), prray_1.default.from(arr.slice(-1000, 3)));
    t.deepEqual(yield pp.slice(-3, 1000), prray_1.default.from(arr.slice(-3, 1000)));
    t.not(yield pp.slice(-3, 1000), yield pp); // Immutable
}));
