"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const sinon = require("sinon");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
ava_1.default('prray some', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.is(prray_1.default.from([1, 2, 3]).some(test_utils_1.isEven), true);
    t.is(prray_1.default.from([1, 3, 5]).some(test_utils_1.isEven), false);
}));
ava_1.default('prraypromise some', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.is(yield test_utils_1.toPrrayPromise([1, 2, 3]).some(test_utils_1.isEven), true);
    t.is(yield test_utils_1.toPrrayPromise([1, 3, 5]).some(test_utils_1.isEven), false);
}));
ava_1.default('prray some compatibility 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const func = sinon.fake(() => false);
    const prr = prray_1.default.from(['a', 'b', 'c']);
    prr.some(func);
    t.is(func.called, true);
    t.is(func.callCount, 3);
    t.is(func.args[0][0], 'a');
    t.is(func.args[0][1], 0);
    t.is(func.args[0][2], prr);
    t.is(func.args[1][0], 'b');
    t.is(func.args[1][1], 1);
    t.is(func.args[1][2], prr);
    t.is(func.args[2][0], 'c');
    t.is(func.args[2][1], 2);
    t.is(func.args[2][2], prr);
}));
ava_1.default('prray some compatibility 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const func = sinon.fake(() => true);
    const prr = prray_1.default.from(['a', 'b', 'c']);
    prr.some(func);
    t.is(func.callCount, 1);
}));
ava_1.default('prraypromise some compatibility 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const func = sinon.fake(() => false);
    const prr = prray_1.default.from(['a', 'b', 'c']);
    const pp = test_utils_1.toPrrayPromise(prr);
    yield pp.some(func);
    t.is(func.called, true);
    t.is(func.callCount, 3);
    t.is(func.args[0][0], 'a');
    t.is(func.args[0][1], 0);
    t.is(func.args[0][2], prr);
    t.is(func.args[1][0], 'b');
    t.is(func.args[1][1], 1);
    t.is(func.args[1][2], prr);
    t.is(func.args[2][0], 'c');
    t.is(func.args[2][1], 2);
    t.is(func.args[2][2], prr);
}));
ava_1.default('prraypromise some compatibility 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const func = sinon.fake(() => true);
    const prr = prray_1.default.from(['a', 'b', 'c']);
    const pp = test_utils_1.toPrrayPromise(prr);
    yield pp.some(func);
    t.is(func.callCount, 1);
}));
