"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
const p1 = prray_1.default.from([1, 3]);
const p2 = prray_1.default.from([1, 2]);
const pp1 = test_utils_1.toPrrayPromise([1, 3]);
const pp2 = test_utils_1.toPrrayPromise([1, 2]);
ava_1.default('prray someAsync', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.true(p1.someAsync(test_utils_1.isGte3Async) instanceof Promise);
    t.true(p1.someAsync(test_utils_1.isGte3) instanceof Promise);
    t.is(yield p1.someAsync(test_utils_1.isGte3Async), true);
    t.is(yield p2.someAsync(test_utils_1.isGte3Async), false);
    t.is(yield p1.someAsync(test_utils_1.isGte3), true);
    t.is(yield p2.someAsync(test_utils_1.isGte3), false);
    t.is(yield p1.someAsync(test_utils_1.isGte3Async, { concurrency: 1 }), true);
}));
ava_1.default('prraypromise someAsync', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.true(pp1.someAsync(test_utils_1.isGte3Async) instanceof Promise);
    t.true(pp1.someAsync(test_utils_1.isGte3) instanceof Promise);
    t.is(yield pp1.someAsync(test_utils_1.isGte3Async), true);
    t.is(yield pp2.someAsync(test_utils_1.isGte3Async), false);
    t.is(yield pp1.someAsync(test_utils_1.isGte3), true);
    t.is(yield pp2.someAsync(test_utils_1.isGte3), false);
    t.is(yield pp1.someAsync(test_utils_1.isGte3Async, { concurrency: 1 }), true);
}));
