"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
const func = (a, b) => a - b;
const getTests = () => {
    return [
        [],
        [2],
        [4, 2],
        // ['3','b',1,2,'a',4,'2000'],
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
    ];
};
ava_1.default('prray sort', (t) => __awaiter(void 0, void 0, void 0, function* () {
    for (const arr of getTests()) {
        const p = prray_1.default.from(arr);
        const expect = prray_1.default.from(arr.sort(func));
        t.deepEqual(p.sort(func), expect);
        t.deepEqual(p.sort(), expect);
        t.deepEqual(p, expect); // mutable
    }
}));
ava_1.default('prraypromise sort', (t) => __awaiter(void 0, void 0, void 0, function* () {
    for (const arr of getTests()) {
        const pp = test_utils_1.toPrrayPromise(arr);
        const expect = prray_1.default.from(arr.sort(func));
        t.deepEqual(yield pp.sort(func), expect);
        t.deepEqual(yield pp.sort(), expect);
        t.deepEqual(yield pp, expect); // mutable
    }
}));
