"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const prraypromise_1 = require("../src/prraypromise");
const test_utils_1 = require("./test-utils");
const funcAsync = (a, b) => test_utils_1.delay(100).then(() => a - b);
const func = (a, b) => a - b;
const getTests = () => {
    return [
        [],
        [2],
        [4, 2],
        // ['3','b',1,2,'a',4,'2000'],
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
        test_utils_1.genRandArr(),
    ];
};
ava_1.default('prray sortAsync', (t) => __awaiter(void 0, void 0, void 0, function* () {
    for (const arr of getTests()) {
        const p = prray_1.default.from(arr);
        const expect = prray_1.default.from(arr.sort(func));
        t.true(p.sortAsync(funcAsync) instanceof prraypromise_1.PrrayPromise);
        t.true(p.sortAsync(func) instanceof prraypromise_1.PrrayPromise);
        t.true(p.sortAsync() instanceof prraypromise_1.PrrayPromise);
        t.deepEqual(yield p.sortAsync(funcAsync), expect);
        t.deepEqual(yield p.sortAsync(func), expect);
        t.deepEqual(yield p.sortAsync(), expect);
        t.is(yield p.sortAsync(), p); // mutable
        t.is(yield p.sortAsync(funcAsync), p); // mutable
    }
}));
ava_1.default('prraypromise sortAsync', (t) => __awaiter(void 0, void 0, void 0, function* () {
    for (const arr of getTests()) {
        const pp = test_utils_1.toPrrayPromise(arr);
        const expect = prray_1.default.from(arr.sort(func));
        t.true(pp.sortAsync(funcAsync) instanceof prraypromise_1.PrrayPromise);
        t.true(pp.sortAsync(func) instanceof prraypromise_1.PrrayPromise);
        t.true(pp.sortAsync() instanceof prraypromise_1.PrrayPromise);
        t.deepEqual(yield pp.sortAsync(funcAsync), expect);
        t.deepEqual(yield pp.sortAsync(func), expect);
        t.deepEqual(yield pp.sortAsync(), expect);
        t.is(yield pp, yield pp.sortAsync()); //  mutable
        t.is(yield pp, yield pp.sortAsync(funcAsync)); //  mutable
    }
}));
