"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
require("source-map-support/register");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
ava_1.default('prray splice 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    t.deepEqual(prr.splice(2, 0, 'drum'), prray_1.default.from([]));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'drum', 'mandarin', 'sturgeon']));
}));
ava_1.default('prray splice 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    t.deepEqual(prr.splice(2, 0, 'drum', 'guitar'), prray_1.default.from([]));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'drum', 'guitar', 'mandarin', 'sturgeon']));
}));
ava_1.default('prray splice 3', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'drum', 'mandarin', 'sturgeon']);
    t.deepEqual(prr.splice(3, 1), prray_1.default.from(['mandarin']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'drum', 'sturgeon']));
}));
ava_1.default('prray splice 4', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'drum', 'sturgeon']);
    t.deepEqual(prr.splice(2, 1, 'trumpet'), prray_1.default.from(['drum']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'trumpet', 'sturgeon']));
}));
ava_1.default('prray splice 5', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'trumpet', 'sturgeon']);
    t.deepEqual(prr.splice(0, 2, 'parrot', 'anemone', 'blue'), prray_1.default.from(['angel', 'clown']));
    t.deepEqual(prr, prray_1.default.from(['parrot', 'anemone', 'blue', 'trumpet', 'sturgeon']));
}));
ava_1.default('prray splice 6', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['parrot', 'anemone', 'blue', 'trumpet', 'sturgeon']);
    t.deepEqual(prr.splice(prr.length - 3, 2), prray_1.default.from(['blue', 'trumpet']));
    t.deepEqual(prr, prray_1.default.from(['parrot', 'anemone', 'sturgeon']));
}));
ava_1.default('prray splice 7', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    t.deepEqual(prr.splice(-2, 1), prray_1.default.from(['mandarin']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'sturgeon']));
}));
ava_1.default('prray splice 8', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    t.deepEqual(prr.splice(2), prray_1.default.from(['mandarin', 'sturgeon']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown']));
}));
ava_1.default('prraypromise splice 1', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(2, 0, 'drum'), prray_1.default.from([]));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'drum', 'mandarin', 'sturgeon']));
}));
ava_1.default('prraypromise splice 2', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(2, 0, 'drum', 'guitar'), prray_1.default.from([]));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'drum', 'guitar', 'mandarin', 'sturgeon']));
}));
ava_1.default('prraypromise splice 3', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'drum', 'mandarin', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(3, 1), prray_1.default.from(['mandarin']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'drum', 'sturgeon']));
}));
ava_1.default('prraypromise splice 4', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'drum', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(2, 1, 'trumpet'), prray_1.default.from(['drum']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'trumpet', 'sturgeon']));
}));
ava_1.default('prraypromise splice 5', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'trumpet', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(0, 2, 'parrot', 'anemone', 'blue'), prray_1.default.from(['angel', 'clown']));
    t.deepEqual(prr, prray_1.default.from(['parrot', 'anemone', 'blue', 'trumpet', 'sturgeon']));
}));
ava_1.default('prraypromise splice 6', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['parrot', 'anemone', 'blue', 'trumpet', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(prr.length - 3, 2), prray_1.default.from(['blue', 'trumpet']));
    t.deepEqual(prr, prray_1.default.from(['parrot', 'anemone', 'sturgeon']));
}));
ava_1.default('prraypromise splice 7', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(-2, 1), prray_1.default.from(['mandarin']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown', 'sturgeon']));
}));
ava_1.default('prraypromise splice 8', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(['angel', 'clown', 'mandarin', 'sturgeon']);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.deepEqual(yield pp.splice(2), prray_1.default.from(['mandarin', 'sturgeon']));
    t.deepEqual(prr, prray_1.default.from(['angel', 'clown']));
}));
