"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = require("ava");
const prray_1 = require("../src/prray");
const test_utils_1 = require("./test-utils");
const arr = ['a', 'b'];
ava_1.default('prray unshift', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(arr);
    t.is(prr.unshift('c'), 3);
    t.is(prr.unshift('d', 'e'), 5);
    t.deepEqual(prr, prray_1.default.from(['d', 'e', 'c', 'a', 'b']));
}));
ava_1.default('prraypromise unshift', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const prr = prray_1.default.from(arr);
    const pp = test_utils_1.toPrrayPromise(prr);
    t.is(yield pp.unshift('c'), 3);
    t.is(yield pp.unshift('d', 'e'), 5);
    t.deepEqual(prr, prray_1.default.from(['d', 'e', 'c', 'a', 'b']));
}));
